//
// 3dnowtest.c written by Hino Ryo
//
//  a0 = x
//  b0 = y
//  (a'+b'j) = (a+bj)^2 - (x+yj)
//           = a*a-b*b-x + (2*a*b-y)j
//

#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <windowsx.h>
#include <ddraw.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <amdlib.h>

#ifdef _MSC_VER
// We don't need EMMS instruction warnings
#pragma warning(disable:4799)
#endif


/*********XCb`**********/

//vZ[`؂ւ
//asmLq3DNow,Fpu[`̎gpon,off
//rIŗD揇ʂ3DNow,Fpu,C(=ǂoff)
//qk
//ƑǗD揇ʂ͏ォBǂ͖O킩ˁH
//Soff(`)CŋLqꂽ̂gpB
#define Use_3DNow_SIMD
//#define Use_3DNow_NOSIMD
//#define Use_Fpu_K6
//#define Use_Fpu_Pen

//vZ͈͂̐؂ւ
#define RectType1

//\̗L
#define Draw2Surface

//s3DNow`FbNon,off
#if defined(Use_3DNow_SIMD)
	#define Use_3DNow
#elif defined(Use_3DNow_NOSIMD)
	#define Use_3DNow
#endif

/***************************/


//ȂȃO[oϐ
LPDIRECTDRAW lpDirectDrawObject;
LPDIRECTDRAWSURFACE lpPrimary;
HRESULT ddreturn;
DDSURFACEDESC ddsd;
BYTE *lpDDMemory;
BOOL cb24bppFlag;


int WINAPI WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow);
long CALLBACK WindowProc ( HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam );
BOOL DrawingDirectDrawSurface ( int r, int g, int b );
BOOL Mandelbrot(float xmin, float xmax, float ymin, float ymax, int maxiter);
BOOL Check3DNow(void);
int CalcByC(float x, float y, int maxiter);
int CalcBy3DNow_SIMD(float x, float y, int maxiter);
int CalcBy3DNow_NOSIMD(float x, float y, int maxiter);
int CalcByFpu_Pen(float x, float y, int maxiter);
int CalcByFpu_K6(float x, float y, int maxiter);

int CalcByC(float x, float y, int maxiter){
	float a, b, a2, b2;
	int count;

	a = x;
	b = y;
	a2 = a * a;
	b2 = b * b;
	count = maxiter;
	while (a2 + b2 <= 4 && count){
		b = 2 * a * b - y;
		a = a2 - b2 - x;
		a2 = a * a;
		b2 = b * b;
		count--;
	}
	return count;
}

int CalcByFpu_K6(float x, float y, int maxiter){
	float a2b2; //a*a + b*b
	int count;

	__asm{
		align 16
		mov			ecx, maxiter
		fld			y				; st = y
		fld			x				; st = x y
		fld			st(0)			; st = x x y
		fld			st(2)			; st = y x x y

		mov			edx, 40800000h	; IEEE-32(4.0)
		mov			a2b2, edx
	brotloop:
									; st = b a x y

		fld			st(0)			; st = b b a x y
		fmul		st, st(0)		; st = bb b a x y
		fld			st(2)			; st = a bb b a x y
		fmul		st(3), st		; st = a bb b aa x y
		fmulp		st(2), st		; st = bb ab aa x y
		cmp			a2b2, edx

		fld			st(2)			; st = aa bb ab aa x y
		fadd		st, st(1)		; st = aa+bb bb ab aa x y
		fstp		a2b2			; st = bb ab aa x y

		fadd		st, st(3)		; st = bb+x ab aa x y
		fsubp		st(2), st		; st = ab aa-bb-x x y
		ja			lexit
		dec			ecx
		fadd		st, st(0)		; st = 2ab aa-bb-x x y
		fsub		st, st(3)		; st = 2ab-y aa-bb-x x y
		jnz			brotloop
	lexit:
		fcompp						; st = ? ?
		fcompp						; st =
		mov			count, ecx
	};
	return count;
}

int CalcByFpu_Pen(float x, float y, int maxiter){
	float a2b2; //a*a + b*b
	int count;

	__asm{
		align 16
		mov			ecx, maxiter
		fld			y				; st = y
		fld			x				; st = x y
		fld			st(0)			; st = x x y
		fld			st(2)			; st = y x x y

		mov			edx, 40800000h	; IEEE-32(4.0)
		mov			a2b2, edx
	brotloop:
									; st = b a x y

		fld			st(1)			; st = a b a x y
		fmul		st, st			; st = aa b a x y
		fld			st(1)			; st = b aa b a x y
		fmul		st, st			; st = bb aa b a x y
				
		fld			st(1)			; st = aa bb aa b a x y
		fsub		st, st(5)		; st = aa-x bb aa b a x y
		fxch		st(4)			; st = a bb aa b aa-x x y
		fmulp		st(3), st		; st = bb aa ab aa-x x y
		fadd		st(1), st		; st = bb aa+bb ab aa-x x y
		fsubp		st(3), st		; st = aa+bb ab aa-bb-x x y
		fxch		st(1)			; st = ab aa+bb aa-bb-x x y
		fadd		st, st			; st = 2ab aa+bb aa-bb-x x y
		cmp			a2b2, edx
		ja			lexit

		fsub		st, st(4)		; st = 2ab-y aa+bb aa-bb-x x y
		fxch		st(1)			; st = aa+bb 2ab-y aa-bb-x x y
		fstp		a2b2			; st = 2ab-y aa-bb-x x y
		dec			ecx
		jnz			brotloop
		fld			st(0)			; st = ? ? ? ? ?
	lexit:
		fstp		st(0)			; st = ? ? ? ?
		fcompp						; st = ? ?
		fcompp						; st =
		mov			count, ecx
	};
	return count;
}

int CalcBy3DNow_SIMD(float x, float y, int maxiter){
	int count;

	__asm{
		align 16
		femms
		movd		mm0, y
		psllq		mm0, 32
		movd		mm1, x
		mov			ecx, maxiter
		por			mm0, mm1		; mm0 =  y | x
		mov			edx, 40800000h	; edx = IEEE-32(4.0)
		movq		mm1, mm0		; mm1 =  y | x
		movd		mm5, edx		; mm5 =  0 | 4.0
		mov			eax, edx		; eax = IEEE-32(4.0)
		psllq		mm5, 28h		; mm5 = -0 | 0
		movq		mm6, mm5

	brotloop:
									; mm0 = b     | a
									; mm1 = y     | x
									; mm5 = -0    | 0
									; mm6 = -0    | 0
		cmp			eax, edx
		movq		mm2, mm0		; mm2 = b     | a
		pfmul		(mm0, mm0)		; mm0 = bb    | aa
		ja			lexit
		punpckldq	mm3, mm2		; mm3 =  a    | ?
		pxor		mm6, mm0		; mm6 = -bb   | aa
		pfmul		(mm3, mm2)		; mm3 = ab    | ?
		pfacc		(mm0, mm6)		; mm0 = aa-bb | aa+bb
		dec			ecx
		movd		eax, mm0
		pfadd		(mm3, mm3)		; mm3 = 2ab   | ?
		punpckhdq	mm0, mm3		; mm0 = 2ab   | aa-bb
		movq		mm6, mm5
		pfsub		(mm0, mm1)		; mm0 = 2ab-y | aa-bb-x
		jnz			brotloop
	lexit:
		mov			count, ecx
		femms
	};
	return count;
}

int CalcBy3DNow_NOSIMD(float x, float y, int maxiter){
	int count;

	__asm{
		align 16
		femms
		movd		mm6, x
		movd		mm7, y
		mov			ecx, maxiter
		mov			edx, 40800000h	; edx = IEEE-32(4.0)
		movq		mm0, mm6
		movq		mm1, mm7
		mov			eax, edx

	brotloop:
									; mm0 = a
									; mm1 = b
									; mm6 = x
									; mm7 = y
		movq		mm2, mm0
		pfmul		(mm0, mm0)		; aa
		movq		mm4, mm1
		pfmul		(mm1, mm2)		; ab
		cmp			eax, edx
		movq		mm3, mm0
		pfsub		(mm0, mm6)		; aa-x
		pfmul		(mm4, mm4)		; bb
		pfadd		(mm1, mm1)		; 2ab
		ja			lexit

		pfadd		(mm3, mm4)		; aa+bb
		dec			ecx
		pfsub		(mm1, mm7)		; 2ab-y
		movd		eax, mm3
		pfsub		(mm0, mm4)		; aa-bb-x
		jnz			brotloop
	lexit:
		mov			count, ecx
		femms
	};
	return count;
}

BOOL Mandelbrot(float xmin, float xmax, float ymin, float ymax, int maxiter){
	int i, j, imax, jmax, count;
	float x, y, dx, dy;

	//TCY
	dx = xmax - xmin;
	dy = ymax - ymin;
	if (dx * 479 > dy * 639){
		imax = 639;
		jmax = (int)(639 * dy / dx + 0.5);
	}else{
		imax = (int)(479 * dx / dy + 0.5);
		jmax = 479;
	}
	dx /= imax;
	dy /= jmax;

	//vZ
	for (i = 0; i <= imax; i++){
		x = xmin + i * dx;
		lpDDMemory = (BYTE *) ddsd.lpSurface + i * (cb24bppFlag == TRUE ? 3 : 4);
		for (j = 0; j <= jmax; j++){
			y = ymax - j * dy;

			#if defined(Use_3DNow_SIMD)
				count = CalcBy3DNow_SIMD(x, y, maxiter);

			#elif defined(Use_3DNow_NOSIMD)
				count = CalcBy3DNow_NOSIMD(x, y, maxiter);

			#elif defined(Use_Fpu_K6)
				count = CalcByFpu_K6(x, y, maxiter);

			#elif defined(Use_Fpu_Pen)
				count = CalcByFpu_Pen(x, y, maxiter);

			#else
				count = CalcByC(x, y, maxiter);
			#endif

			#ifdef Draw2Surface
				lpDDMemory[0] = (BYTE)count;
				lpDDMemory[1] = (BYTE)count<<4;
				lpDDMemory[2] = (BYTE)count>>4;
				lpDDMemory += ddsd.lPitch;
			#endif
		}
	}
	return TRUE;
}

int WINAPI WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
	MSG msg;
	HWND hwnd;
	WNDCLASS wc;
	static char ClassName[] = "3DNowTest";

	//[jO
	lpCmdLine = lpCmdLine;
	hPrevInstance = hPrevInstance;

	//EChE̍쐬
	wc.style = CS_HREDRAW | CS_VREDRAW;
	wc.lpfnWndProc = WindowProc;
	wc.cbClsExtra = 0;
	wc.cbWndExtra = 0;
	wc.hInstance = hInstance;
	wc.hIcon = LoadIcon( hInstance, IDI_APPLICATION );
	wc.hCursor = LoadCursor( NULL, IDC_ARROW );
	wc.hbrBackground = NULL;
	wc.lpszMenuName = ClassName;
	wc.lpszClassName = ClassName;
	RegisterClass( &wc );

	hwnd = CreateWindowEx( WS_EX_TOPMOST, ClassName, ClassName, WS_POPUP, 0, 0,
		GetSystemMetrics(SM_CXSCREEN), GetSystemMetrics(SM_CYSCREEN),
		NULL, NULL, hInstance, NULL );
	if( !hwnd ) return FALSE;
	ShowWindow( hwnd, nCmdShow );
	UpdateWindow( hwnd );
	SetFocus( hwnd );
	ShowCursor( FALSE );

	//Rcmnṽ`FbN
	#ifdef Use_3DNow
		if (!Check3DNow()){
			ShowCursor( TRUE );
			MessageBox(hwnd, "CPU3DNow!ɑΉĂ܂B\n", "傢܂", MB_OK);
			DestroyWindow ( hwnd );
			return FALSE;
		}
	#endif

	//DirectDraw쐬
	ddreturn = DirectDrawCreate( NULL, &lpDirectDrawObject, NULL );
	if ( ddreturn != DD_OK ){
		DestroyWindow( hwnd );
		return FALSE;
	}
	ddreturn = lpDirectDrawObject->SetCooperativeLevel( hwnd, DDSCL_EXCLUSIVE | DDSCL_FULLSCREEN );
	if ( ddreturn != DD_OK ){
		DestroyWindow( hwnd );
		return FALSE;
	}
	cb24bppFlag = TRUE;
	ddreturn = lpDirectDrawObject->SetDisplayMode( 640, 480, 24 );
	if ( ddreturn != DD_OK ){
		cb24bppFlag = FALSE;
		ddreturn = lpDirectDrawObject->SetDisplayMode( 640, 480, 32 );
		if ( ddreturn != DD_OK ){
			DestroyWindow( hwnd );
			return FALSE;
		}
	}
		
	memset ( &ddsd, 0, sizeof( DDSURFACEDESC ) );
	ddsd.dwSize = sizeof ( ddsd );
	ddsd.dwFlags = DDSD_CAPS;
	ddsd.ddsCaps.dwCaps = DDSCAPS_PRIMARYSURFACE;
	ddreturn = lpDirectDrawObject->CreateSurface( &ddsd, &lpPrimary, NULL );
	if ( ddreturn != DD_OK ){
		DestroyWindow( hwnd );
		return FALSE;
	}

	//KɓhԂ(^)
	if ( !DrawingDirectDrawSurface (0, 0, 0) ){
		DestroyWindow ( hwnd );
		return FALSE;
	}

	while ( 1 ){
		while( PeekMessage( &msg, NULL, 0, 0, PM_NOREMOVE ) ){
			if( !GetMessage( &msg, NULL, 0, 0 ) )
				return msg.wParam;
			TranslateMessage ( &msg );
			DispatchMessage ( &msg );
		}

		//T[tF[XbN
		memset ( &ddsd, 0, sizeof( DDSURFACEDESC ) );
		ddsd.dwSize = sizeof( ddsd );
		ddreturn = lpPrimary->Lock( NULL, &ddsd, DDLOCK_WAIT, NULL );
		if( ddreturn != DD_OK ){
			DestroyWindow ( hwnd );
			return FALSE;
		}

		DWORD TickCount = GetTickCount();

		#ifdef RectType1
			Mandelbrot(-0.9f, 2.1f, -1.2f, 1.2f, 2048);
		#else
			Mandelbrot(0.6f, 1.2f, 0.0f, 0.4f, 2048);
		#endif

		TickCount = GetTickCount() - TickCount;

		//AbN
		lpPrimary->Unlock ( NULL );

		char tmp[256];
		sprintf(tmp, "s   %6.3fs    \n", (float)TickCount / 1000);
		ShowCursor( TRUE );
		MessageBox(hwnd, tmp, "", MB_OK);
		DestroyWindow ( hwnd );
	}
	return 0L;
}

long CALLBACK WindowProc( HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam )
{
	switch( message ){
	case WM_DESTROY:
		if ( lpDirectDrawObject != NULL ){
			if ( lpPrimary != NULL )
				lpPrimary->Release();
			lpDirectDrawObject->Release();
		}
		ShowCursor( TRUE );
		PostQuitMessage( 0 );
		break;
	default:
		return DefWindowProc (hwnd,message,wParam,lParam);
	}
	return 0L;
}

//KȐFœhԂB
//sNZtH[}bglĂȂ̂ŐF͂
BOOL DrawingDirectDrawSurface ( int r, int g, int b )
{
	HRESULT 			ddreturn;
	DDSURFACEDESC		ddsd;
	BYTE				*lpDDMemory;


	memset ( &ddsd, 0, sizeof( DDSURFACEDESC ) );
	ddsd.dwSize = sizeof( ddsd );
	ddreturn = lpPrimary->Lock( NULL, &ddsd, 0, NULL );
	if( ddreturn != DD_OK ){
		return FALSE;
	}

	int x,y;
	for (y = 0; y < 480; y++){
		lpDDMemory = (BYTE *) ddsd.lpSurface + y * ddsd.lPitch;
		for (x = 0; x < 640; x++){
			*lpDDMemory++ = r;
			*lpDDMemory++ = g;
			*lpDDMemory++ = b;
			if( !cb24bppFlag ) lpDDMemory++;
		}
	}
	lpPrimary->Unlock ( NULL );
	return TRUE;
}

BOOL Check3DNow(void){
	__asm {
		pushfd					// save EFLAGS to stack.
		pop		eax				// store EFLAGS in EAX.
		mov		edx, eax		// save in EBX for testing later.
		xor		eax, 0x200000	// switch bit 21.
		push	eax				// copy "changed" value to stack.
		popfd					// save "changed" EAX to EFLAGS.
		pushfd
		pop		eax
		cmp		eax, edx		// See if bit changeable.
		jz		No3DNow			// CPU doesn't support CPUID instruction.

		mov		eax,0x80000000	// Check for support of extended functions.
		CPUID
		cmp		eax,0x80000001	// Make sure function 0x80000001 supported.
		jb		No3DNow
                                // Now we know extended functions are supported.
		mov		eax,0x80000001	// Get extended features.
		xor		edx, edx		// Clear edx - not really necessary.
		CPUID
        test    edx,0x80000000	// edx contains extended feature flags
		jz		No3DNow			// bit 31 = 1 => 3DNow!
	};
	return TRUE;
No3DNow:
	return FALSE;
}
